#--------------------------
#- Prime Sieve Benchmark --
#--------------------------

$BATCH = 50;
$BENCH_TIME = 15; 

$SIZE = 500;  # finds primes up to SIZE*2+1
	      # (only tests odd numbers)
$ON = 1;
$OFF = 0;

@flags[$SIZE] = $ON;

sub sieve
{
    local($i);
    local($k);
    local($start);
    local($still_prime);
    local($prime);
    
    $count = 0;
    for ($i = 1; $i <= $SIZE; $i++) {
    	$flags[$i] = $ON;
    }
    for ($i = 1; $i <= $SIZE; $i++) {
	$still_prime = $flags[$i];
	if ($still_prime == $ON) {
	    $prime = $i + $i;
	    $prime++; 
	    $start = $prime + $i;
	    for ($k = $start; $k <= $SIZE; $k += $prime) {
		$flags[$k] = $OFF;
	    } 
	    $count++; 
	}
    }
    $count;
}

print "prime sieve benchmark ...\n";

($t1,,,) = times;
$cycles = 0;
while (1) {
	($t,,,) = times;
	if ($t >= ($t1 + $BENCH_TIME)) {
		last;
	}
	for ($iter = 1; $iter <= $BATCH; $iter++) {
    		if (do sieve() != 167) {	
			print "whoops!\n";
    		}
	}
	$cycles = $cycles + $BATCH;
}
($t2,,,) = times;
$t2 = $t2 - $t1;
printf("%f sieves per second\n", $cycles / $t2);

# display results
print "  2";  # 2 is also a prime
for ($i = 1; $i <= $SIZE; $i++) {
    if ($flags[$i] == $ON) {
	printf(" %3d", $i*2+1);
    }
}

print "\n";

